# coding: utf-8
from __future__ import absolute_import, with_statement

import re
from itertools import chain
import argparse
import json
import subprocess


parser = argparse.ArgumentParser(description='Creates a connection')

parser.add_argument('filename',
                      metavar='DESCRIPTION_FILE',
                      type=str,
                      help='filename for the connection description file')


ALLOWED_HOSTNAME = re.compile(r'^([a-zA-Z0-9._-]+@)?[a-zA-Z0-9._-]+$')


def get_command(hops):
    for hop in hops:
        if not ALLOWED_HOSTNAME.match(hop):
            raise RuntimeError("Illegal hop: %r" % hop)
    return ['gnome-terminal', '-e', ' '.join('ssh -A -t %s' % hop for hop in hops)]


def main():
    args = parser.parse_args()
    with open(args.filename, 'rb') as fp:
        data = json.load(fp)

    subprocess.Popen(get_command(data['hops']))
